/* SPDX-License-Identifier: MIT
 * Copyright (c) 2020 Kingizor */

#include <stdio.h>
#include <stdlib.h>
#include "bd_comp.h"

int main (int argc, char *argv[]) {

    #define APP_NAME "bd_decomp"

    puts(APP_NAME " - A \"big data\" decompressor for DKC2 and DKC3.");
    if (argc != 4) {
        puts("\nUsage: " APP_NAME " OUTPUT INPUT [OFFSET]\n\n"
             "e.g.   "   APP_NAME " data.bin dkc3.sfc 0x215058\n"
             "       "   APP_NAME " output.bin compressed_file.bin\n"
        );
        return 1;
    }

    if (bd_decompress_file_to_file(
        argv[1], argv[2], strtol(argv[3], NULL, 0))
    ) {
        fprintf(stderr, "Error: %s\n", bd_get_error());
        return 1;
    }

    puts("Done!");
    return 0;
}

