/* SPDX-License-Identifier: MIT
 * Copyright (c) 2020 Kingizor */

#ifndef BD_INTERNAL
#define BD_INTERNAL

enum ERROR_CONDITIONS {
    READ_ERROR  = 1,
   WRITE_ERROR  = 2,
    DECOMP_QUIT = 4
};

/* Compressor things */
struct DATA_STREAM {
    unsigned char *stream;
    int len; /* buffer size */
    int pos;    /* byte address */
    int half;   /* +1 nibble */
};
struct COMPRESSOR {
    struct DATA_STREAM i;
    struct DATA_STREAM o;
    enum ERROR_CONDITIONS flag;
};

int bd_compress (struct COMPRESSOR*);


/* Decompressor things */
struct DECOMPRESSOR {
    unsigned char *input;
    unsigned char *output;
    int input_len;
    int x; /* Output offset */
    int y; /* Input  offset */
    int half;
    enum ERROR_CONDITIONS flag;
};

int bd_decompress(struct DECOMPRESSOR*);

void bd_set_error (const char*);

#endif
